package io.fabric8.kubernetes.api.model;

import org.assertj.core.api.AbstractAssert;
import org.assertj.core.api.Assertions;


import io.fabric8.kubernetes.assertions.AssertFactory;
import io.fabric8.kubernetes.assertions.NavigationListAssert;

import static org.assertj.core.api.Assertions.assertThat;
import static io.fabric8.kubernetes.assertions.internal.Assertions.assertThat;
import static io.fabric8.openshift.assertions.Assertions.assertThat;

/**
 * Abstract base class for {@link NamedContext} specific assertions - Generated by CustomAssertionGenerator.
 */
public abstract class AbstractNamedContextAssert<S extends AbstractNamedContextAssert<S, A>, A extends NamedContext> extends AbstractAssert<S, A> {

  /**
   * Creates a new <code>{@link AbstractNamedContextAssert}</code> to make assertions on actual NamedContext.
   * @param actual the NamedContext we want to make assertions on.
   */
  protected AbstractNamedContextAssert(A actual, Class<S> selfType) {
    super(actual, selfType);
  }


  /**
   * Navigates to the property additionalProperties so that assertions can be done on it
   */
  public org.assertj.core.api.MapAssert additionalProperties()  {
    // check that actual NamedContext we want to make assertions on is not null.
    isNotNull();

    // return the assertion for the property
    return (org.assertj.core.api.MapAssert) assertThat(actual.getAdditionalProperties()).describedAs(io.fabric8.kubernetes.assertions.Assertions.joinDescription(this, "additionalProperties"));
  }


  /**
   * Navigates to the property context so that assertions can be done on it
   */
  public ContextAssert context()  {
    // check that actual NamedContext we want to make assertions on is not null.
    isNotNull();

    // return the assertion for the property
    return (ContextAssert) assertThat(actual.getContext()).describedAs(io.fabric8.kubernetes.assertions.Assertions.joinDescription(this, "context"));
  }


  /**
   * Navigates to the property name so that assertions can be done on it
   */
  public org.assertj.core.api.StringAssert name()  {
    // check that actual NamedContext we want to make assertions on is not null.
    isNotNull();

    // return the assertion for the property
    return (org.assertj.core.api.StringAssert) assertThat(actual.getName()).describedAs(io.fabric8.kubernetes.assertions.Assertions.joinDescription(this, "name"));
  }


}
