package io.fabric8.kubernetes.api.model;

import org.assertj.core.api.AbstractAssert;
import org.assertj.core.api.Assertions;
import org.assertj.core.util.Objects;


import io.fabric8.kubernetes.assertions.AssertFactory;
import io.fabric8.kubernetes.assertions.NavigationListAssert;

import static org.assertj.core.api.Assertions.assertThat;
import static io.fabric8.kubernetes.assertions.internal.Assertions.assertThat;
import static io.fabric8.openshift.assertions.Assertions.assertThat;

/**
 * Abstract base class for {@link ServicePort} specific assertions - Generated by CustomAssertionGenerator.
 */
public abstract class AbstractServicePortAssert<S extends AbstractServicePortAssert<S, A>, A extends ServicePort> extends AbstractAssert<S, A> {

  /**
   * Creates a new <code>{@link AbstractServicePortAssert}</code> to make assertions on actual ServicePort.
   * @param actual the ServicePort we want to make assertions on.
   */
  protected AbstractServicePortAssert(A actual, Class<S> selfType) {
    super(actual, selfType);
  }


  /**
   * Navigates to the property additionalProperties so that assertions can be done on it
   */
  public org.assertj.core.api.MapAssert additionalProperties()  {
    // check that actual ServicePort we want to make assertions on is not null.
    isNotNull();

    // return the assertion for the property
    return (org.assertj.core.api.MapAssert) assertThat(actual.getAdditionalProperties()).describedAs(io.fabric8.kubernetes.assertions.Assertions.joinDescription(this, "additionalProperties"));
  }


  /**
   * Navigates to the property name so that assertions can be done on it
   */
  public org.assertj.core.api.StringAssert name()  {
    // check that actual ServicePort we want to make assertions on is not null.
    isNotNull();

    // return the assertion for the property
    return (org.assertj.core.api.StringAssert) assertThat(actual.getName()).describedAs(io.fabric8.kubernetes.assertions.Assertions.joinDescription(this, "name"));
  }


  /**
   * Verifies that the actual ServicePort's nodePort is equal to the given one.
   * @param nodePort the given nodePort to compare the actual ServicePort's nodePort to.
   * @return this assertion object.
   * @throws AssertionError - if the actual ServicePort's nodePort is not equal to the given one.
   */
  public S hasNodePort(Integer nodePort) {
    // check that actual ServicePort we want to make assertions on is not null.
    isNotNull();

    // overrides the default error message with a more explicit one
    String assertjErrorMessage = "\nExpecting nodePort of:\n  <%s>\nto be:\n  <%s>\nbut was:\n  <%s>";
    
    // null safe check
    Integer actualNodePort = actual.getNodePort();
    if (!Objects.areEqual(actualNodePort, nodePort)) {
      failWithMessage(assertjErrorMessage, actual, nodePort, actualNodePort);
    }

    // return the current assertion for method chaining
    return myself;
  }

  /**
   * Verifies that the actual ServicePort's port is equal to the given one.
   * @param port the given port to compare the actual ServicePort's port to.
   * @return this assertion object.
   * @throws AssertionError - if the actual ServicePort's port is not equal to the given one.
   */
  public S hasPort(Integer port) {
    // check that actual ServicePort we want to make assertions on is not null.
    isNotNull();

    // overrides the default error message with a more explicit one
    String assertjErrorMessage = "\nExpecting port of:\n  <%s>\nto be:\n  <%s>\nbut was:\n  <%s>";
    
    // null safe check
    Integer actualPort = actual.getPort();
    if (!Objects.areEqual(actualPort, port)) {
      failWithMessage(assertjErrorMessage, actual, port, actualPort);
    }

    // return the current assertion for method chaining
    return myself;
  }

  /**
   * Navigates to the property protocol so that assertions can be done on it
   */
  public org.assertj.core.api.StringAssert protocol()  {
    // check that actual ServicePort we want to make assertions on is not null.
    isNotNull();

    // return the assertion for the property
    return (org.assertj.core.api.StringAssert) assertThat(actual.getProtocol()).describedAs(io.fabric8.kubernetes.assertions.Assertions.joinDescription(this, "protocol"));
  }


  /**
   * Navigates to the property targetPort so that assertions can be done on it
   */
  public IntOrStringAssert targetPort()  {
    // check that actual ServicePort we want to make assertions on is not null.
    isNotNull();

    // return the assertion for the property
    return (IntOrStringAssert) assertThat(actual.getTargetPort()).describedAs(io.fabric8.kubernetes.assertions.Assertions.joinDescription(this, "targetPort"));
  }


}
